# dth-pingpong-mobileapp
> 
> Minimum supported Android API: 28 (Android 9).\
> Minimum required iOS version: 14
> 
Flutter application for ping pong score tracking. supports friends, elo tracking, match creation and planning. 

![lang](https://img.shields.io/badge/Flutter-02569B?style=for-the-badge&logo=flutter&logoColor=white) ![os1](https://img.shields.io/badge/Android-3DDC84?style=for-the-badge&logo=android&logoColor=white)
---

# Installing

Installation options are available for major mobile platforms. Although we mainly support android, all the features are cross-compatible with iOS

### Stable release channel (Android only)
Grab one of the builds from the releases page or run:
```bash
flutter build apk
```
Production artifacts will be found in the `build\app\outputs\apk\` directory.

**RRC (Rolling Release Channel)**
There's also a Rolling release available as pre-release builds. They will be released in a much quicker update ring (every other commit i'd assume) and are mostly debug builds so they'll be very heavy and *likely* broken.

### Building instructions (Android)
Make sure you have [Flutter](https://flutter.dev/), [Android Studio](https://developer.android.com/studio), and [Visual Studio Code](https://code.visualstudio.com/) installed. Install the suggested Flutter, Dart, and linting extensions in Visual Studio Code.

Run the following commands to ensure all dependencies are met:
```bash
flutter doctor
```

You'll be guided through a first-time setup that checks for platform tools, dependencies, and missing components.

Once the setup is complete you can navigate to the repo folder and run
```bash
flutter run
```
If you want to build debug you can also run 
```bash
flutter build apk --debug
```
Build artifacts for Android are saved under `build\app\outputs\apk`.

### Building instructions (iOS)
**MAJOR WORD OF WARNING: iOS builds are NOT officially supported, and we have NO clue as to why or how certain things just break on the xCode build (namely some icons and some api calls). if you encounter these issues you are free to patch them, and, if you seem fit, hit me up with a PR**

Make sure you have [Flutter](https://flutter.dev/), [xCode and Apple Developer Tools](https://apps.apple.com/en/app/xcode/id497799835?mt=12), [cocoapods](https://formulae.brew.sh/formula/cocoapods), and [Visual Studio Code](https://code.visualstudio.com/) installed.
Install the suggested Flutter, Dart, and linting extensions in Visual Studio Code and set up xcode for "iOS on iphone" developement. Once that is done, go in the project's folder and run the following command to ensure that your build environment is properly configured, any missing component will be highlighted
```bash
flutter doctor
```

Once you've done that, from the same terminal, run this command to generate a .IPA file - once you're done it's a matter of sideloading it to your device. since i've never owned an apple device i have no idea how to do that. iOS artifacts are saved in `build/ios/runner/`.

```bash
flutter build ios
```
